# Copyright 1999-2006 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2

inherit eutils ruby

DESCRIPTION="Jabber reminder component"
HOMEPAGE="http://zadolbator.sourceforge.net"
SRC_URI="mirror://sourceforge/${PN}/${P}.tar.gz"
LICENSE="GPL-2"
SLOT="0"
KEYWORDS="~amd64 ~x86"

DEPEND=">=net-im/jabber-base-0.0
	>=dev-lang/ruby-1.8"

IUSE=""

# Patch applied: reversed --prefix location from 'config' to 'install' section
patched_ruby_einstall() {
	local siteruby

	RUBY_ECONF="${RUBY_ECONF} ${EXTRA_ECONF}"
	if [ -f install.rb ] ; then
		${RUBY} install.rb config "$@" \
			${RUBY_ECONF} || die "install.rb config failed"
		${RUBY} install.rb install --prefix=${D}/usr "$@" \
			${RUBY_ECONF} || die "install.rb install failed"
	elif [ -f setup.rb ] ; then
		${RUBY} setup.rb config "$@" \
			${RUBY_ECONF} || die "setup.rb config failed"
		elog "${RUBY} setup.rb install --prefix=${D}/usr \"$@\""
		${RUBY} setup.rb install --prefix=${D} "$@" \
			${RUBY_ECONF} || die "setup.rb install failed"
	elif [ -f extconf.rb -o -f Makefile ] ; then
		make DESTDIR=${D} "$@" install || die "make install failed"
	else
		siteruby=$(${RUBY} -r rbconfig -e 'print Config::CONFIG["sitedir"]')
		insinto ${siteruby}
		doins *.rb || die "doins failed"
	fi
}

src_install() {
	patched_ruby_einstall "$@" || die

	insinto /etc/jabber
	newins ${WORKDIR}/${P}/contrib/zadolbator.yaml ${PN}.yaml
	fperms 600 /etc/jabber/${PN}.yaml
	fowners jabber:jabber /etc/jabber/${PN}.yaml

	exeinto /etc/init.d
	newexe ${WORKDIR}/${P}/contrib/zadolbator.initd zadolbator
}

pkg_postinst() {
	einfo "A sample configuration file has been installed in
	/etc/jabber/zadolbator.yaml."
	einfo "Please edit it, and the configuration of you Jabber server to match."
	einfo "You also need to create a directory reminder.yourdomain.com in"
	einfo "/var/spool/jabber/ and chown it to jabber:jabber and create there"
	einfo "database that zadolbator will use."
}
