#
# zadolbator: simple reminder component for Jabber service
#
# Copyright (C) 2007 Alexander Tsvyashchenko
#
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU
# General Public License as published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with this program; if not,
# write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

class SearchEventsMsgCmd

  @@cmd_name = 'search'
  @@cmd_help = 'specify list of case-sensitive strings to search for or nothing to get all events'

  def SearchEventsMsgCmd.cmd_name
    @@cmd_name
  end

  def cmd_name
    @@cmd_name
  end

  def SearchEventsMsgCmd.cmd_help
    @@cmd_help
  end

  def cmd_help
    @@cmd_help
  end

  def process(msg, log)
    text = StringIO.open(msg.body)
    text.readline # Skip first line - it should be command name
    lines = text.readlines
    lines.delete_if { |line| line.chomp.empty? }

    res_events = ''
    found_events = 0
    # Not optimal - O(N*M), but I doubt it's important here ...
    Storage::Event.find(:all).each { |event|
      if not lines.empty?
        # Skip to next event if there are no matches
        next unless lines.find { |line| event.ical.index(line.chomp) }
      end
      res_events += event.ical + "\n"
      found_events += 1
    }

    text.close

    msg.body = "Success: #{found_events} event(s) found\n\n" + res_events
    return false # Nothing is changed, so no updates
  end
end
